#include <pc.h>

#include "event.h"
#include "mouse.h"
#include "refresh.h"

/*

	input.c

		Input stuff.

		C-Desktop
		Copyright (C)1998, Brett Porter.

*/


/*
	DATA
*/

const	byte	kScanToASCII[] =
		{ 0x00, 0x1B, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x30, 0x2D, 0x3D, 0x08, 0x09, 0x71, 0x77, 0x65, 0x72,
		  0x74, 0x79, 0x75, 0x69, 0x6F, 0x70, 0x5B, 0x5D, 0x0D, 0x00, 0x61, 0x73, 0x64, 0x66, 0x67, 0x68, 0x6A, 0x6B, 0x6C, 0x3B,
		  0x27, 0x60, 0x00, 0x5C, 0x7A, 0x78, 0x63, 0x76, 0x62, 0x6E, 0x6D, 0x2C, 0x2E, 0x2F, 0x00, 0x2A, 0x00, 0x20 };

/*
	FUNCTION	PROTOTYPES
*/

static	void	Input_PollKeyboard( void );

/*
	FUNCTION	DEFINITIONS
*/

void	Input_Check( void )
{
	Mouse_Poll();

	Input_PollKeyboard();
}

void	Input_PollKeyboard( void )
{
	if ( kbhit())
	{
		Event_HandleKeypress( getxkey());
	}
}




